% Exercise 12

% =============================================
% Pole Placement Design for Tank (Problem 35)
% =============================================
% Tank parameters
T1 = 3;
K1 = 0.03;
A = .1;
s = tf('s');
% ========================
% Controller without integrator 
% ========================
u_forward = 0;
% R(s) = s^3 + 3s^2 + 3s + 1
l2 = 0;
p2 = 0;
l1 = 1/3;
l0 = (3 - l1)/3;
p0 = 10/3;
p1 = (3 - l0)/.3; 
% simulation
options = simset('Solver','ode45');
% Disturbance step
r_step = 0;
d_step = 0.01;
sim('ECE441_Ex12_solution_simulink_P25',[0,50],options);
figure(1);
plot(t,y,'k--');
grid
hold;
xlabel('time [sec]')
ylabel('level [m]')
% Disturbance step with disturbance feedforward
u_forward = 1;
sim('ECE441_Ex12_solution_simulink_P25',[0,50],options);
figure(1);
plot(t,y);
legend('without disturbance feedforward','With disturbance feedforward')
xlabel('time [sec]')
ylabel('level [m]')

% ========================
% Controller with integrator 
% ========================
u_forward = 0;
% R(s) = s^4 + 4s^3 + 6s^2+ 4s + 1
% 3\,l_1\,s^4 + (3\,l_0 + l_1)\,s^3 + (l_0 + 0.3\,p_2)\,s^2 + 0.3\,p_1\,s +
% 0.3\,p_0
l0 = 0;
l2 = 1/3;
l1 = (4 - l2)/3;
p2 = (6 - l1)/.3;
p1 = 4/.3;
p0 = 1/.3;
% simulation
options = simset('Solver','ode45');
% Disturbance step
r_step = 0;
d_step = 0.01;
sim('ECE441_Ex12_solution_simulink_P25',[0,50],options);
figure(2);
plot(t,y,'k--');
grid
hold;
xlabel('time [sec]')
ylabel('level [m]')
% Disturbance step with disturbance feedforward
u_forward = 1;
sim('ECE441_Ex12_solution_simulink_P25',[0,50],options);
figure(2);
plot(t,y);
legend('without disturbance feedforward','With disturbance feedforward')
xlabel('time [sec]')
ylabel('level [m]')

% ===============================0
% Cascade Control (Problem 36)
% ===============================
% Plant parameters
K_3 = .03;
T_3 = 3;
A_4 = .5;
G3 = K_3/(1 + s*T_3);
G4 = 1/A_4/s;
% Inner loop design (pole placement)
l0p = 1/3;
p1 = (2 - l0p)/.03;
p0 = 1/.03;
C3 = (p0 + p1*s)/l0p/s;
T3 = minreal(1/(1 + 1/C3/G3));
% Outer loop
G = G4*T3;
T = 1/(1 + s)^2;
Q = minreal(T/G);
C4 = Q/(1 - T);
[numC4 denC4] = tfdata(C4,'v');
% reference step response
r_step = 30;
d_step2 = 0;
d_step3 = 0;
options = simset('Solver','ode45');
sim('ECE441_Ex12_solution_simulink_P26',[0,50],options);
figure(3);
plot(t,y);
legend('Reference step response')
grid
% disturbence q_2 step response
r_step = 0;
d_step2 = .01;
d_step3 = 0;
sim('ECE441_Ex12_solution_simulink_P26',[0,50],options);
figure(4);
plot(t,y);
grid
hold;
% disturbence q_o step response
r_step = 0;
d_step2 = 0;
d_step3 = .01;
sim('ECE441_Ex12_solution_simulink_P26',[0,50],options);
figure(4);
plot(t,y,'k');
legend('Disturbance step q_2','Disturbance step q_o')



